# 测试驱动开发

> 一种敏捷技术实践和设计方法。通过3顶帽子的过程，通过单元测试驱动代码的实现

在TDD中，针对类的公共接口编写测试。这些测试关注类的行为，而不是类的实现。 在编写响应的产品代码之前，先写好测试。从而确保程序员集中精力创建容易使用的接口。TDD结束后，测试需要保留，并充当活文档。并且在几乎每次构建时都运行所有的测试，确保代码依然按照原有的设计正常工作。如果变更改变了代码的行为，测试也会失败，发出错误提示。

## TDD的三顶帽子

> “红色，绿色，重构”

XP中说:"在拥有一个失败的测试之前，不要写任何产品代码"

1. 思考：我们想要代码拥有什么样的行为，并并创建相应的测试；
2. 红色：在写好测试之后，运行全部的测试套件，让新的测试失败掉；
3. 绿色： 只需编写足够让测试通过的代码；
4. 重构：重新审视代码并寻找可以改进的地方；
5. 重复： 重新从第1步开始循环

> 采用小增量式TDD成功的关键。

## 测试概念

* Stub（测试桩，伪实现）：Stub一般指为了让测试通过而编写的一些伪实现，这些伪实现会继承需要测试的接口。而在测试时将接口的实现指向这些伪实现。Stub是预先定义好的，硬编码的实现。 initialize -> exercise -> verify
* Mock（模拟对象）：Mock则是动态的，需要在测试中动态的定义预期的行为以及返回值等。 initialize -> set expectations -> exercise -> verify

## 提高设计的可测试性的准则

* 尽量使用组合(composition)而非继承(inheritance)
* 避免使用static关键字，以及Singleton模式
* 隔离依赖（Isolate dependencies）
* 依赖注入(Inject denpendencies)

## 单元测试模式

* 断言模式
* 组织及构建家具模式
* 测试类总体模式

## 驱动不可预测的功能

* 与时间相关的功能

    抽象出系统时间/虚拟的系统时间

* 多线程代码

    > 挑战：测试驱动并发程序时不仅要关注顺序行为，还要关注并发行为
    
    * 测试线程安全性
    * 测试阻塞状态